#ifndef malicious_h
#define malicious_h

struct MaliciousFunc
{
	/** Save the pointer to the original function */
	static void (*pf)(void);

	static void pre()
	{
		cout << "    <here is the fun code>" << endl;
	};
	static void post()
	{
		cout << "    <or here>" << endl;
	};
	static void f()
	{
		pre();
		(*pf)();
		post();
	};

	static void attack(void* pobj, const unsigned func_idx, const unsigned vtablesize)
	{
		assert( 0 <= func_idx && func_idx < vtablesize);

		//Casting stuff
		void*** p = (void***)pobj;

		// Save pointer to original function
		//    p[0] is the vtable-pointer
		pf = ( void (*)(void)) p[0][func_idx];

		// Create malicious vtable and copy the original one
		void** vtable_mal = new void*[vtablesize];
		memcpy(vtable_mal, p[0], vtablesize*sizeof(void*));

		// Replace the entry with our malicious function
		vtable_mal[func_idx] = (void*) &MaliciousFunc::f;

		// Change vtable of obj to malicious one
		p[0] = (void**) vtable_mal;

		//Attention: cannot change pointer in the vtable since original vtable
		//is in readonly segment.
	};
};


/** actually, would be put into .cpp file... */
void (*MaliciousFunc::pf)(void);

#endif







